Star-geometry-3d
================

The purpose of this library is to help create clean and decorated 3D
geometries. These geometries are suitable to be partitioned into
enclosures using the star-enclosures-3d library. It also provides
mechanisms to construct triangle-related app data, detect
inconsistencies and dump the resulting geometry in various formats (OBJ,
VTK, C code chunks).

How to build
------------

Star-geometry-3d relies on the [CMake](http://www.cmake.org) and the
[RCMake](https://gitlab.com/vaplv/rcmake/) package to build and
depends on the [RSys](https://gitlab.com/vaplv/rsys/) library. Some tests 
also depend on the [SD3UT](https://gitlab.com/meso-star/star-3dut/)
library.

First ensure that CMake and a C compiler that is compliant with C89 are
installed on your system. Then install the RCMake package as well as all
the aforementioned prerequisites. Finally generate the project from the
`cmake/CMakeLists.txt` file by appending to the `CMAKE_PREFIX_PATH`
variable the install directories of its dependencies.

Release notes
-------------

### Version 0.1

First version and implementation of the star-geometry-3d API.

-   Creation of geometries in multiple steps, allowing advanced
    deduplication and application-data management

-   Dump of geometries as OBJ or VTK files or as C code chunks

License
-------

Star-geometry-3d is Copyright (C) 2019-2020 |Meso|Star>
(<a href="mailto:contact@meso-star.com" class="email">contact@meso-star.com</a>).
Itis free software released under the GPLv3+ license: GNU GPL
version 3 or later. You are welcome to redistribute it under certain
conditions; refer to the COPYING files for details.
