# sgreen

## Overview

sgreen is a postprocess of Green function binary files, as produced by the
*stardis* program (https://gitlab.com/meso-star/stardis). The main purpose
of sgreen is to compute Monte-Carlo results by applying Green functions to
new settings, enabling ultra-fast Monte-Carlo computations.

## How to build

Stardis relies on the [CMake](http://www.cmake.org) and the
[RCMake](https://gitlab.com/vaplv/rcmake/) package to build.
It also depends on the
[RSys](https://gitlab.com/vaplv/rsys/) library as well as on the
[OpenMP](http://www.openmp.org) 2.0 specification to parallelize its
computations.

First ensure that CMake and a C compiler that implements the OpenMP 2.0
specification are installed on your system. Then install the RCMake package as
well as all the aforementioned prerequisites. Finally generate the project from
the `cmake/CMakeLists.txt` file by appending to the `CMAKE_PREFIX_PATH`
variable the install directories of its dependencies.

## Release notes

### Version 0.1.1

- Check binary Green file format version (this require stardis 0.5.1).
- Man improvement.
- Ensure C89 compatibility.

### Version 0.1

- Compatible with stardis v0.5.0 binary Green function files.
- Can produce a summary of a Green function in HTML format.
- Can apply a Green function to new settings and output the corresponding Monte-Carlo results.
